from machine import Pin, PWM ,ADC
from rotary_irq_esp import RotaryIRQ  
from time import sleep

def initStuff():
  a=Pin(4,Pin.IN, Pin.PULL_UP)
  b=Pin(5,Pin.IN, Pin.PULL_UP)
  
      
def show():  
  colours = [ 7,5,1,2,4,3,6,-1]
  range=30
  maxpwm = 1024
  pwmfreq=5000
  index = 0
  swval = 0
  lastswval = 0
  on = True
  redramp = 0
  bluramp = 512
  grnramp = 1024
  redrampdelta = 5
  blurampdelta = 7
  grnrampdelta = 3
  red=PWM(Pin(13),int(pwmfreq))
  grn=PWM(Pin(12),int(pwmfreq))
  blu=PWM(Pin(14),int(pwmfreq))  
  red.duty(int(maxpwm / 2))
  grn.duty(int(maxpwm / 2))      
  blu.duty(int(maxpwm / 2))
  r = RotaryIRQ(pin_num_clk=4,pin_num_dt=5,min_val=0,max_val=range,reverse=True,range_mode=RotaryIRQ.RANGE_WRAP)
  initStuff()
  lastval = 0
  sw = ADC(0)
  chan = 0
  redval = 0
  grnval = 0
  bluval = 0
  lastredval = 0
  lastgrnval = 0
  lastbluval = 0
  while True:
    chan = chan + 1
    if chan > 2:
      chan = 0
    sleep(0.01)
    val = r.value()
    col = colours[index]
    if col < 0:
      if chan == 0:
        redramp=redramp + redrampdelta
        if (redramp >= maxpwm) or (redramp <= 0):
          redrampdelta = -redrampdelta
          if redramp > maxpwm:
            redramp = maxpwm
          if redramp < 0:
            redramp = 0 
        grnramp=grnramp + grnrampdelta
        if (grnramp >= maxpwm) or (grnramp <= 0):
          grnrampdelta = -grnrampdelta
          if grnramp > maxpwm:
            grnramp = maxpwm
          if grnramp < 0:
            grnramp = 0 
        bluramp=bluramp + blurampdelta
        if (bluramp >= maxpwm) or (bluramp <= 0):
          blurampdelta = -blurampdelta
          if bluramp > maxpwm:
            bluramp = maxpwm
          if bluramp < 0:
            bluramp = 0
      if chan == 0:             
        red.duty(int(redramp * (val / range)))
      if chan == 1:
        blu.duty(int(bluramp * (val / range)))
      if chan == 2:
        grn.duty(int(grnramp * (val / range))) 
    delta = val - lastval
    if delta < (-range / 2):
      index = index + 1
      if index > 7:
        index = 0
        lastredval = -1
        lastbluval = -1
        lastgrnval = -1     
      col = colours[index]        
    if delta > range / 2:
      index = index - 1
      if index < 0:
        index = 7
      col = colours[index]     
    if delta != 0: 
      pwm = int((val / range) * maxpwm)
      if col > 0:
        redval = pwm *(col & 1)
        grnval = pwm *((col & 4) >> 2)
        bluval = pwm *((col & 2) >> 1)    
      lastval = val
    swval = sw.read()
    if (lastswval != swval) and (swval > 800):
      index = 0
      lastredval = -1
      lastbluval = -1
      lastgrnval = -1     
      if on:
        on = False 
        redval = 0
        grnval = 0
        bluval = 0  
      else:
        on = True
        redval = int(maxpwm / 2)
        grnval = int(maxpwm / 2)
        bluval = int(maxpwm / 2)
        index = 0
        
    lastswval = swval       
    if col > 0:
      if chan == 0 and redval != lastredval:
        red.duty(redval)
        lastredval = redval 
      if chan == 1 and grnval != lastgrnval:
        grn.duty(grnval)
        lastgrnval = grnval       
      if chan == 2 and bluval != lastbluval:
        blu.duty(bluval)
        lastbluval = bluval       

  
  
  